;; -*- Mode: Lisp; Package: VISU-SMOTS -*-

;;;  (c) copyright 2007 by
;;;           Irne Durand (idurand@labri.fr)

;;; This library is free software; you can redistribute it and/or
;;; modify it under the terms of the GNU Library General Public
;;; License as published by the Free Software Foundation; either
;;; version 2 of the License, or (at your option) any later version.
;;;
;;; This library is distributed in the hope that it will be useful,
;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
;;; Library General Public License for more details.
;;;
;;; You should have received a copy of the GNU Library General Public
;;; License along with this library; if not, write to the
;;; Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;;; Boston, MA  02111-1307  USA.


;; faire que les ) trailing (ou manquantes) ne bloquent pas l'analyse
;; tuer les processus avant de tout quitter

(in-package :visu-smots)

;(defun get-absolute-filename-from-browser ()
;  (car (clim-demo::file-selector-test)))

(defmethod process-yield ())

(defun clear-language-pane ()
  (window-clear *language-pane*))

(defun clear-sword-pane ()
  (window-clear *sword-pane*))

(defun clear-lexpr-pane ()
  (window-clear *lexpr-pane*))

(defun clear-problem-pane ()
  (window-clear *problem-pane*))

(defun scroll-language-pane ()
  (scroll-extent *language-pane* 0 0))

(defun scroll-sword-pane ()
  (scroll-extent *sword-pane* 0 0))

(defun scroll-lexpr-pane ()
  (scroll-extent *lexpr-pane* 0 0))

(defun force-lexpr-pane ()
  (force-output *lexpr-pane*))

(defun force-language-pane ()
  (force-output *language-pane*))

(defun scroll-problem-pane ()
  (scroll-extent *problem-pane* 0 0))

(defun display-current-problem ()
  (clear-problem-pane)
  (when (problem *spec*)
    (display-problem (problem *spec*))
    (scroll-problem-pane)))

(defun display-current-sword ()
  (clear-sword-pane)
  (when (sword *spec*)
    (display-sword (sword *spec*))
    (scroll-sword-pane)))

(defun display-current-language ()
  (clear-language-pane)
  (when (language *spec*)
    (display-language (language *spec*))
;;    (force-language-pane)
    (scroll-language-pane)))

(defun display-current-lexpr ()
  (clear-lexpr-pane)
  (when (lexpr *spec*)
    (display-lexpr (lexpr *spec*))
;;    (force-lexpr-pane)
    (scroll-lexpr-pane)))

(defun display-current-spec ()
  (when *spec*
    (display-current-problem)
    (display-current-language)
    (display-current-sword)
    (display-current-lexpr)
    (window-clear *output-stream*)))

(defun set-and-display-current-lexpr (lexpr)
  (set-current-lexpr lexpr)
  (display-current-lexpr))

(defun set-and-display-current-sword (sword)
  (set-current-sword sword)
  (display-current-sword))

(defun set-and-display-current-language (language)
  (set-current-language language)
  (display-current-language))

(defun load-sword (new-sword)
  (when new-sword
    (set-and-display-current-sword new-sword)))

(defun load-lexpr (new-lexpr)
  (when new-lexpr
    (set-and-display-current-lexpr new-lexpr)))

(defun clear-current-sword ()
  (setf (sword *spec*) nil)
  (clear-sword-pane))

(defun clear-current-lexpr ()
  (setf (lexpr *spec*) nil)
  (clear-lexpr-pane))

;;; language

(defun clear-current-language ()
  (setf (language *spec*) nil)
  (clear-language-pane))

(defun load-language (name new-language)
  (when new-language
    (setf (name new-language) name)
    (set-and-display-current-language new-language)))

;;; problem
 (defun clear-current-problem ()
  (setf (problem *spec*) nil))

(defun set-and-display-current-problem (problem)
  (set-current-problem problem)
  (display-current-problem))

(defun set-and-display-current-spec (spec)
  (set-current-spec spec)
  (display-current-spec))
