(in-package :smots)
(defvar *data-relative-directory* "Data/")

(defun default-directory ()
  "The default directory."
  #+allegro (excl:current-directory)
  #+clisp (#+lisp=cl ext:default-directory #-lisp=cl lisp:default-directory)
  #+cmu (ext:default-directory)
  #+cormanlisp (ccl:get-current-directory)
  #+lispworks (hcl:get-working-directory)
  #+lucid (lcl:working-directory)
  #-(or allegro clisp cmu cormanlisp lispworks lucid) (truename "."))

(defun initial-data-directory ()
  (concatenate 'string
;;	       (namestring (default-directory))
	       smots-system::*smots-directory*
	       *data-relative-directory*))
  
(defvar *data-directory* (initial-data-directory))

(defun back-up-file (file)
  (when (probe-file file)
      (let ((nfile (concatenate 'string file ".bak")))
        (back-up-file nfile)
        (rename-file file nfile))))

(defun absolute-filename (filename)
  (concatenate 'string *data-directory* filename))

(defun load-file-from-absolute-filename  (absolute-filename reader)
  (with-open-file (foo absolute-filename :direction :input :if-does-not-exist nil)
    (if foo
	(funcall reader foo)
	(prog1
	    nil
	  (format *error-output* "unable to open ~A~%" absolute-filename)))))

