(in-package :smots)

(defvar *smots-readtable* (copy-readtable))

(defun input-sword-n (s &optional (number t))
  (with-input-from-string (stream s) (parse-sword-n stream number)))

(defun input-sword (s)
  (input-sword-n s nil))

(defun input-lexpr (s)
  (input-lexpr-n s nil))

(defun input-lexpr-n (s &optional (number t))
  (with-input-from-string (stream s) (parse-lexpr-n stream number)))

(defun input-sletter (s)
  (with-input-from-string (stream s) (parse-sletter stream)))

(defun input-mletter (s)
  (with-input-from-string (stream s) (parse-mletter stream)))

(defun read-constraints (stream)
  (handler-case
      (parse-lexprs stream)
    (smots-parse-error ()
      (prog1 nil (format *error-output* "parse error~%")))
    (all-errors ()
      (prog1 nil
        (format *error-output* "Unable to read constraints")))))

(defun read-swords (stream)
  (handler-case
      (parse-swords stream)
    (smots-parse-error ()
      (prog1 nil (format *error-output* "parse error~%")))
    (all-errors ()
      (prog1 nil
        (format *error-output* "Unable to read swords")))))

(defun read-sword (stream)
  (handler-case
      (parse-sword stream)
    (smots-parse-error ()
      (prog1 nil (format *error-output* "parse error~%")))
    (all-errors ()
      (prog1 nil
        (format *error-output* "Unable to read a sword")))))

(defun read-lexpr (stream)
  (handler-case
      (parse-lexpr stream)
    (smots-parse-error ()
      (prog1 nil (format *error-output* "parse error~%")))
    (all-errors ()
      (prog1 nil
        (format *error-output* "Unable to read an lexpr")))))

(defun read-slanguage (stream)
  (handler-case
      (parse-slanguage stream)
    (smots-parse-error ()
      (prog1 nil (format *error-output* "parse error~%")))
    (all-errors ()
      (prog1 nil
        (format *error-output* "Unable to read a slanguage")))))
