(in-package :smots)

(defvar *ljoin-lop* (make-lop "J" #'ljoin 2))

(defclass ljoin (gljoin)
  ((lop :allocation :class
	:initform *ljoin-lop*
	:reader lop)))

(defun ljoinp (lexpr)
  (typep lexpr 'ljoin))

(defun make-ljoin (lexprs)
  (if (disjoint-alphabets lexprs)
      (make-mix lexprs)
      (make-assoc-lexpr lexprs 'ljoin 'sword 'slanguage)))

(defgeneric mix-with-mletters (lexpr1 alphac malpha2)
  (:documentation ""))

(defmethod mix-with-mletters ((lexpr1 alanguage) (alphac alphabet)
			      (malpha2 alphabet))
  (let ((malphabet (projection malpha2 alphac)))
    (if (aemptyp malphabet)
	lexpr1
	(make-mix (cons lexpr1 (delanoy-args malphabet))))))
			
(defmethod ljoin ((lexpr1 alanguage) (lexpr2 mix))
;;  (format *error-output* "ljoin alanguage mix~A J ~A~%" lexpr1 lexpr2)
  (if (delanoyp lexpr2 (malphabet-of lexpr1))
      lexpr1
      (call-next-method)))
 
(defmethod ljoin ((lexpr1 mix) (lexpr2 alanguage))
;;  (format *error-output* "ljoin mix alanguage~%")
  (if (delanoyp lexpr1 (malphabet-of lexpr2))
      lexpr2
      (call-next-method)))
 
(defmethod ljoin ((lexpr1 alanguage) (lexpr2 alanguage))
;;  (format *error-output* "ljoin alanguage ~A J ~A~%" lexpr1 lexpr2)
  (if (or (empty-wordp lexpr1)
	  (empty-wordp lexpr2))
      (empty-sword)
      (let* ((malpha1 (malphabet-of lexpr1))
	     (malpha2 (malphabet-of lexpr2))
	     (alpha1 (alphabet-of lexpr1))
	     (alpha2 (alphabet-of lexpr2))
	     (alphai (aintersection alpha1 alpha2)))
	(if
	  (aemptyp alphai)
	  (mix lexpr1 lexpr2)
	  (let* ((e1 (mix-with-mletters lexpr1 (aset-difference alpha2 alpha1) malpha2))
		 (e2 (mix-with-mletters lexpr2 (aset-difference alpha1 alpha2) malpha1))
		 (ei (lintersection e1 e2)))
	     (if (equivalent ei (make-lintersection (list e1 e2)))
		 (progn  (format *error-output* "intersection n a rien apporte~%")
			(make-ljoin (list lexpr1 lexpr2)))
		 ei))))))

(defmethod extreme-letters ((lexpr ljoin) &optional (last nil))
;;  (format *error-output* "extreme-letters ljoin~%")
  (let ((fls (cartesian-product (mapcar
				 (lambda (arg)
				     (mapcar (lambda (sletter)
						 (make-sword
						  (list sletter)))
					     (extreme-letters arg last)))
				 (args lexpr)))))
    (remove-duplicates
     (mappend #'(lambda (sl)
			(extreme-letters sl last))
	      (mapcar
	       (lambda (tuple)
		   (reduce #'ljoin tuple))
	       fls)))))


(defun check-op (e1 e2 op)
  (let* ((l1 (compute-language e1))
	 (l2 (compute-language e2))
	 (l (funcall op l1 l2))
	 (e (funcall op e1 e2))
	 (le (compute-language e)))
    (or (equivalent l le)
	(values nil
		(set-difference (words l) (words le))
		(set-difference (words le) (words l))))))

(defmethod elementaryp ((ljoin ljoin))
  (let ((language (memo ljoin)))
    (and language (elementaryp language))))
