(in-package :smots)

(defvar *union-lop* (make-instance
		     'lop
		     :symbol-lop "U"
		     :lfun-lop #'lunion
		     :priority 2
		     :cfun-lop #'+
		     :fun-lop #'union))
				   
(defclass lunion (s-mixin bool-mixin assoc-lexpr)
  ((lop :allocation :class :initform *union-lop* :reader lop)))

(defun lunionp (o)
  (or (typep o 'lunion) (swordp o)))

(defun make-lunion (lexprs)
  (make-assoc-lexpr lexprs 'lunion 'sword 'slanguage))

(defmethod lunion ((lexpr1 alanguage) (lexpr2 alanguage))
  (make-lunion (list lexpr1 lexpr2)))

(defmethod lunion ((lexpr1 alanguage) (lexpr2 mix))
  (if (delanoyp lexpr2 (malphabet-of lexpr1))
      lexpr2
      (call-next-method)))

(defmethod lunion ((lexpr1 mix) (lexpr2 language))
  (if (delanoyp lexpr1 (malphabet-of lexpr2))
      lexpr1
      (call-next-method)))

(defmethod extreme-letters ((lexpr lunion) &optional (last nil))
;;  (format *error-output* "extreme-letters lunion~%")
  (remove-duplicates
   (mappend (lambda (args) (extreme-letters args last))
	    (args lexpr))))

(defmethod clean-args ((lexpr lunion))
  (when *trace-clean-args*
    (format *error-output* "clean-args  lunion ~A~%" lexpr))
  (let ((args (args lexpr)))
    (setf (args lexpr) (remove-if #'empty-languagep args)))
  lexpr)

(defmethod contains-empty-sword ((lunion lunion))
  (some #'contains-empty-sword  (args lunion)))
