(in-package :smots)

(defgeneric set-marks (language &optional pairs))

(defmethod set-marks ((assoc-lexpr assoc-lexpr) &optional (pairs nil))
;;  (format *error-output* "set-marks ~A~%" assoc-lexpr)
  (make-assoc-lexpr (mapcar (lambda (arg)
			      (set-marks arg pairs))
			    (args assoc-lexpr))
		    (class-of assoc-lexpr)
		    (wordtype assoc-lexpr)
		    (languagetype assoc-lexpr)))

(defgeneric set-sequential-marks (lexprs &optional pairs)
  (:documentation "numbers the letters of lexprs starting from 0 or from
		    the value indicated in PAIRS"))

(defmethod set-sequential-marks ((lexprs list) &optional (pairs nil))
  (if (endp lexprs)
      '()
      (progn
	(unless pairs
	  (setf pairs (make-letter-mark-pairs (alphabet-of lexprs))))
	(let ((first (set-marks (car lexprs) pairs)))
	  (let ((newpairs (get-letter-mark-pairs (malphabet-of (cdr lexprs)))))
	    (setf newpairs (set-difference newpairs pairs :key #'car))
	    (cons first (set-sequential-marks (cdr lexprs) (append pairs newpairs))))))))

(defmethod set-marks ((language language) &optional (pairs nil))
;;  (format *error-output* "set-marks slanguage")
  (make-language (mapcar (lambda (sword)
			      (set-marks sword
					   (copy-tree pairs)))
			  (words language))
		 (wordtype language)
		 (languagetype language)))

(defmethod set-marks ((lexprs list) &optional (pairs nil))
  (mapcar (lambda (lexpr)
	    (set-marks lexpr pairs))
	  lexprs))
