(in-package :smots)
;; constants : +sep-open-par+ +sep-closed-par+ +sep-colon+ +sep-arrow+ +sep-comma+
;; +sep-open-bracket+ +sep-closed-bracket+ +sep-open-acc+ +sep-closed-acc+

(defun make-grammar-lexpr ()
  (make-grammar
   :terminals '(U I X J * ~ |(| |)|)
   :start-symbol 'lexpr
   :productions 
   (list
    (make-production 'lexpr '(paren-lexpr))
    (make-production 'paren-lexpr '((open-par lexpr close-par)))
    (make-production 'lexpr '(unary-lexpr))
    (make-production 'lexpr '(assoc-lexpr))
    (make-production 'unary-lexpr '((paren-lexpr unary-op)))
    (make-production 'assoc-lexpr '(term))
    (make-production 'assoc-expr '((term assoc-op assoc-lexpr)))
    (make-production 'unary-op '(~ *))
    (make-production 'assoc-op (list +union+ +intersection+ +mix+ +join+))
    (make-production 'open-par (list +sep-open-par+))
    (make-production 'close-par (list +sep-closed-par+)))))


(make-parser (make-grammar-lexpr))
